﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;

using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using Musi_chan.Tools.WebCapture;

using System.Runtime.InteropServices;
namespace WpfApplication1
{    
    /// <summary>
    /// The follwing code is got from 
    /// http://musi-chan.at.webry.info/200605/article_10.html    
    /// </summary>
    public partial class Window1 : Window
    {
        #region Variables
        // WebBrowser instance to host
        System.Windows.Forms.WebBrowser _browser;
        ObservableCollection<Border> _thumbnails;
        #endregion

        #region Constructor
        public Window1()
        {
            InitializeComponent();
            
            // thumbnail image list is set to the listbox.
            _thumbnails = new ObservableCollection<Border>();
            _listbox.ItemsSource = _thumbnails;

            // create web browser instance to host.
            _browser = new System.Windows.Forms.WebBrowser();
            wfHost.Child = _browser;
            //_browser.Navigated += new NavigatedEventHandler(_browser_Navigated);
            _browser.Navigated += new System.Windows.Forms.WebBrowserNavigatedEventHandler(_browser_Navigated);

            _browser.Navigate(_textbox.Text);
        }
        #endregion

        #region Event handlers
        private void TextBox_PreviewKeyDown(object sender, KeyEventArgs e)
        {
            switch (e.Key)
            { 
                case Key.Return:
                    try
                    {

                                                if (null == _browser.Url || (_browser.Url.ToString() != ((sender as TextBox).Text)))
                            _browser.Url = new Uri((sender as TextBox).Text);
                        /*
                        if (null == _browser.Source || (_browser.Source.ToString() != ((sender as TextBox).Text)))
                            _browser.Source = new Uri((sender as TextBox).Text);
                         */

                    }
                    catch (Exception)
                    {
                        return;
                    }
                    break;
                default:
                    return;
            }
            e.Handled = true;
        }
        
        void _browser_Navigated(object sender, System.Windows.Forms.WebBrowserNavigatedEventArgs e)
        {            
            string uri = _browser.Url.ToString();
            if (_textbox.Text != uri)
                _textbox.Text = uri;
        }
        /*        
        void _browser_Navigated(object sender, NavigationEventArgs e)
        {
            string uri = _browser.Source.ToString();
            if (_textbox.Text != uri)
                _textbox.Text = uri;
        }*/

        void Button_Click(object sender, RoutedEventArgs e)
        {
            addThumbnail();
        }

         void Button_Click_1(object sender, RoutedEventArgs e)
        {
            _thumbnails.Clear();
        }
        #endregion

         /// <summary>
         /// It convertes size value in pixel unit to that in himetric unit.
        /// Pixel単位をHIMETRIC単位に変換するメソッド
        /// </summary>
        /// <param name="size">Pixel単位のサイズ構造体</param>
        /// <param name="hdc">デバイス・コンテキスト（デスクトップの解像度とコンパチであれば無問題？）</param>
        /// <returns>HIMETRIC単位のサイズ構造体</returns>
        private System.Drawing.Size convertPixelToHIMETRIC(System.Drawing.Size size, IntPtr hdc)
        {
            const int HIMETRIC_PER_INCH = 2540;

            System.Drawing.Size newSize = new System.Drawing.Size();

            newSize.Width = (int)((double)size.Width * HIMETRIC_PER_INCH / GetDeviceCaps(hdc, DEVICECAPS.LOGPIXELSX) + 0.5);
            newSize.Height = (int)((double)size.Height * HIMETRIC_PER_INCH / GetDeviceCaps(hdc, DEVICECAPS.LOGPIXELSY) + 0.5);

            return newSize;
        }

        [DllImport("ole32")]
        private static extern int OleDraw(IntPtr pUnk, DVASPECT dwAspect, IntPtr hdcDraw, ref System.Drawing.Rectangle lprcBounds);

        [DllImport("gdi32")]
        private static extern int GetDeviceCaps(IntPtr hdc, DEVICECAPS caps);
        
        void addThumbnail()
        {            
            // TODO: the following code does not work with web pages that use frame tag (FRAMESET tag).
            System.Windows.Forms.HtmlDocument htmlDocument = _browser.Document as System.Windows.Forms.HtmlDocument;            
            System.Windows.Forms.HtmlElement htmlElement = htmlDocument.Body;
            // Now a web page size is got from HtmlElement.ScrollRectangle property
            System.Drawing.Rectangle rectangle = new System.Drawing.Rectangle(new System.Drawing.Point(0,0), htmlElement.ScrollRectangle.Size);
            /*
            Matrix m = PresentationSource.FromVisual(Application.Current.MainWindow).CompositionTarget.TransformToDevice;            
            double dx = m.M11;
            double dy = m.M22;
             * */

            // bitmap image instance is created, which resolution is the same as that of a desktop window.
            using(System.Drawing.Bitmap image = new System.Drawing.Bitmap(rectangle.Size.Width, rectangle.Size.Height, System.Drawing.Graphics.FromHwnd(_browser.Handle)))                
            {
                using (System.Drawing.Graphics graphics = System.Drawing.Graphics.FromImage(image))
                {
                    // IOleObject interface is get from HtmlDocument.DomDocument property.
                    Musi_chan.Tools.WebCapture.IOleObject oleObject = htmlDocument.DomDocument as Musi_chan.Tools.WebCapture.IOleObject;
                    if (null != oleObject)
                    {
                        // getting a bitmap device context.
                        IntPtr imageDC = graphics.GetHdc();
                        IntPtr pUnk = System.Runtime.InteropServices.Marshal.GetIUnknownForObject(_browser.ActiveXInstance);
                        //IntPtr pUnk = System.Runtime.InteropServices.Marshal.GetIUnknownForObject(_browser.ActiveXInstance);
                        try
                        {
                            System.Drawing.Size currentSize = new System.Drawing.Size();
                            // browser current extent size is preserved by the GetExtent() method.
                            oleObject.GetExtent(DVASPECT.DVASPECT_CONTENT, out currentSize);
                            // unit convertion of the capture size from  pixel unit to himetric unit.                        
                            System.Drawing.Size drawingSize = convertPixelToHIMETRIC(rectangle.Size, imageDC);
                            // the above size is set to browser extens size.
                            oleObject.SetExtent(DVASPECT.DVASPECT_CONTENT, ref drawingSize);
                            // draw bitmap image
                            OleDraw(pUnk, DVASPECT.DVASPECT_CONTENT, imageDC, ref rectangle);
                            // now browser extent size is recovered.
                            oleObject.SetExtent(DVASPECT.DVASPECT_CONTENT, ref currentSize);
                        }
                        finally
                        {
                            // alocated resources, device context and pointers, are released.
                            System.Runtime.InteropServices.Marshal.Release(pUnk);
                            graphics.ReleaseHdc(imageDC);
                        }
                    }
                }
                // now, the bitmap insntance that holds the web image is converted to WPF image source.
                System.Windows.Media.Imaging.BitmapSource bitmapSource = System.Windows.Interop.Imaging.CreateBitmapSourceFromHBitmap(
                    image.GetHbitmap(),
                    IntPtr.Zero,
                    Int32Rect.Empty,
                    System.Windows.Media.Imaging.BitmapSizeOptions.FromEmptyOptions());
                
                Border brd = new Border();
                //brd.Width = 200;
                //brd.Height = 200;
                Image img = new Image();
                img.Width  = 200;
                img.Height = 200;
                img.Stretch = Stretch.Uniform;
                img.Source = bitmapSource;
                brd.Child = img;
                _thumbnails.Add(brd);
            }
        }
    }
}
